Index: /trunk/SophyaPI/PI/piaxes.cc
===================================================================
--- /trunk/SophyaPI/PI/piaxes.cc	(revision 2521)
+++ /trunk/SophyaPI/PI/piaxes.cc	(revision 2522)
@@ -41,4 +41,5 @@
   ConfigureTicks();
   ConfigureAutoFontSize();
+  ConfigureAxesCenter();
   setupDone = false;
 }
@@ -111,9 +112,6 @@
 
     // Les axes
-    double x0axes = (xMin+xMax)/2.;
-    double y0axes = (yMin+yMax)/2.;
-    // POUR REZA: ici si on a demande de forcer les axes en x0,y0
-    // alors on le fait ici: il faut faire a peu pres ca:
-    // > if(getaxescenter()) getaxescenter(x0axes,y0axes);
+    double x0axes = (xMin+xMax)/2.,  y0axes = (yMin+yMax)/2.;
+    if(axesCenter) {x0axes = axesCentX0; y0axes = axesCentY0;}
     if(x0axes<xMin || x0axes>xMax) x0axes = (xMin+xMax)/2.;
     if(y0axes<yMin || y0axes>yMax) y0axes = (yMin+yMax)/2.;
@@ -310,4 +308,6 @@
 //	Configuration de la taille de fonte, en mode AutoFontSize.
 //	La taille est exprimée en fraction de la taille totale YMax-Min
+// void  ConfigureAxesCenter(bool fset,double x0,double y0)
+//	Force axe center to be at (x0,y0) or let it be in the middle
 //--
 
@@ -321,8 +321,18 @@
   if (mintl > 1.e-19) fMinTickLen = mintl;
 }
+
 /* --Methode-- */
 void PIAxes::ConfigureAutoFontSize(double fszf)
 {
   if (fszf > 1.e-19) fontSz = fszf;
+}
+
+/* --Methode-- */
+void PIAxes::ConfigureAxesCenter(bool fset,double x0,double y0)
+{
+ axesCenter = fset;
+ if(!axesCenter) return;
+ axesCentX0 = x0;
+ axesCentY0 = y0;
 }
 
Index: /trunk/SophyaPI/PI/piaxes.h
===================================================================
--- /trunk/SophyaPI/PI/piaxes.h	(revision 2521)
+++ /trunk/SophyaPI/PI/piaxes.h	(revision 2522)
@@ -52,4 +52,5 @@
 		       double majtl=0.0125, double mintl=0.007);
   void  ConfigureAutoFontSize(double fszf=0.04);
+  void  ConfigureAxesCenter(bool fset=false,double x0=0.,double y0=0.);
 
   //  virtual void      DrawHorizontalAxe(double xmin, double xmax, double y, 
@@ -96,4 +97,5 @@
   double xMajTickLen,  xMinTickLen;
   double yMajTickLen,  yMinTickLen;
+  bool axesCenter; double axesCentX0,axesCentY0;
 
 };
Index: /trunk/SophyaPI/PI/pidrawer.cc
===================================================================
--- /trunk/SophyaPI/PI/pidrawer.cc	(revision 2521)
+++ /trunk/SophyaPI/PI/pidrawer.cc	(revision 2522)
@@ -65,5 +65,4 @@
   SetAxesFlags(kAxesNone);   // Pas de trace d'axes par defaut 
   SetAxesAutoFontSize();
-  SetAxesCenter();
 
   mDndfg = false;  // Pour controle de l'appel de Detach() si delete
@@ -143,6 +142,4 @@
 //|	kMajTicks , kMinTicks , kLabels , kGridOn
 //|	kAxesDflt , kAxesNone
-// void  SetAxesCenter(bool fset,double x0,double y0)
-//	Force axe center to be at (x0,y0) or let it be in the middle
 // void SetAxesAutoFontSize(bool fg=true)
 //	Si "fg==true", la taille de la fonte pour les labels d'axes (chiffres) est 
@@ -492,13 +489,4 @@
 
 void
-PIDrawer::SetAxesCenter(bool fset,double x0,double y0)
-{
- axesCenter = fset;
- if(!axesCenter) return;
- axesCentX0 = x0;
- axesCentY0 = y0;
-}
-
-void
 PIDrawer::DrawAxes(PIGraphicUC* g)
 {
Index: /trunk/SophyaPI/PI/pidrawer.h
===================================================================
--- /trunk/SophyaPI/PI/pidrawer.h	(revision 2521)
+++ /trunk/SophyaPI/PI/pidrawer.h	(revision 2522)
@@ -30,5 +30,4 @@
 
   virtual void       SetAxesFlags(unsigned int flags=kAxesNone);
-  virtual void       SetAxesCenter(bool fset=false,double x0=0.,double y0=0.);
   inline  void       SetAxesAutoFontSize(bool fg=true) { axesAFSz = fg; }
 
@@ -64,8 +63,5 @@
 
   inline unsigned int GetAxesFlags() { return(axesFlags); }
-  inline  bool        GetAxesCenter() { return(axesCenter); }
-  inline  bool        GetAxesCenter(double &x0,double& y0)
-                       {x0=axesCentX0; y0=axesCentY0; return(axesCenter);}
-  inline  bool        isAxesAutoFontSize() { return axesAFSz; }
+  inline bool         isAxesAutoFontSize() { return axesAFSz; }
 
   inline PIGraphicUC*    GetGraphicUC() { return(mGrUC); }
@@ -132,5 +128,4 @@
   unsigned int axesFlags;
   bool axesAFSz;
-  bool axesCenter; double axesCentX0,axesCentY0;
   PIBaseWdgGen* mBWdg;
   PIGraphicUC* mGrUC;
Index: /trunk/SophyaPI/PI/pieldrw.cc
===================================================================
--- /trunk/SophyaPI/PI/pieldrw.cc	(revision 2521)
+++ /trunk/SophyaPI/PI/pieldrw.cc	(revision 2522)
@@ -565,9 +565,9 @@
     else if (opts.substr(0,11) == "axescenter=") {
       if(opts == "axescenter=") {
-        SetAxesCenter();
+        axeDr.ConfigureAxesCenter();
       } else {
         double x0=0., y0=0.;
         sscanf(opts.substr(11).c_str(),"%lf,%lf",&x0,&y0);
-        SetAxesCenter(true,x0,y0);
+        axeDr.ConfigureAxesCenter(true,x0,y0);
       }
     }