Index: trunk/SophyaPI/PIext/pihisto.cc
===================================================================
--- trunk/SophyaPI/PIext/pihisto.cc	(revision 2522)
+++ trunk/SophyaPI/PIext/pihisto.cc	(revision 2523)
@@ -196,8 +196,8 @@
            || opts=="nostat" || opts=="nostats") SetStats(false);
     else if(opts=="err")      SetError(1);
-    else if(opts=="noerr")    SetError(-1);
+    else if(opts=="noerr" || opts=="nerr")    SetError(-1);
     else if(opts=="autoerr")  SetError(0);
     else if(opts=="fill")     SetFilled(true);
-    else if(opts=="nofill")   SetFilled(false);
+    else if(opts=="nofill" || opts=="nfill")   SetFilled(false);
     else if(opts.substr(0,11) == "statposoff=") {
       float xo=0., yo=0.;
@@ -217,4 +217,21 @@
 }
 
+int
+PIHisto::OptionToString(vector<string> & opt) const
+{
+ PIDrawer::OptionToString(opt);
+
+ if(stats) opt.push_back("stat"); else opt.push_back("nstat");
+ if(error==-1) opt.push_back("noerr");
+   else if(error==0) opt.push_back("autoerr");
+     else if(error==1) opt.push_back("err");
+ if(filled) opt.push_back("fill"); else opt.push_back("nofill");
+
+ char str[256]; sprintf(str,"statposoff=%g,%g",spoX,spoY);
+ opt.push_back(str);
+
+ return 1;
+}
+
 void
 PIHisto::GetOptionsHelpInfo(string& info)
@@ -223,7 +240,7 @@
 info += "  sta,stat,stats:            activate   statistic display\n";
 info += "  nsta,nstat,nostat,nostats: deactivate statistic display\n";
-info += "  err / nerr : draw, do not draw error bars\n";
+info += "  err / noerr,nerr : draw, do not draw error bars\n";
 info += "  autoerr : draw error bars if Marker drawing requested OR Profile histo\n";
-info += "  fill / nofill : fill, do not fill bars with selected color\n";
+info += "  fill / nofill,nfill : fill, do not fill bars with selected color\n";
 info += "  statposoff=OffsetX,OffsetY : Position offset for Stats drawing \n";
 info += "       as a fraction of total size \n";
Index: trunk/SophyaPI/PIext/pihisto.h
===================================================================
--- trunk/SophyaPI/PIext/pihisto.h	(revision 2522)
+++ trunk/SophyaPI/PIext/pihisto.h	(revision 2523)
@@ -16,5 +16,5 @@
   inline  void       SetStats(bool fg=true) {stats=fg;}
   inline  void       SetStatPosOffset(float ofx=-0.01, float ofy=-0.01) 
-          {spoX=ofx; spoY=ofy; }
+                                     {spoX=ofx; spoY=ofy; }
   // fg=-1 pas de barre d'erreur, 1=barres d'erreurs,
   // 0=barres d'erreurs automatiques: trace si HProf ou markeur demande
@@ -25,4 +25,5 @@
 //   Methode de decodage des options
   virtual int        DecodeOptionString(vector<string> & opt, bool rmdecopt=true);
+  virtual int        OptionToString(vector<string> & opt) const;
   virtual void       GetOptionsHelpInfo(string& info);
 
Index: trunk/SophyaPI/PIext/pihisto2d.cc
===================================================================
--- trunk/SophyaPI/PIext/pihisto2d.cc	(revision 2522)
+++ trunk/SophyaPI/PIext/pihisto2d.cc	(revision 2523)
@@ -576,4 +576,36 @@
 }
 
+int PIHisto2D::OptionToString(vector<string> & opt) const
+{
+ PIDrawer::OptionToString(opt);
+ char str[256];
+
+ if(stats) opt.push_back("stat"); else opt.push_back("nstat");
+
+ sprintf(str,"statposoff=%f,%f",spoX,spoY);
+ opt.push_back(str);
+
+ if(mTypDisp==0) sprintf(str,"h2disp=var");
+  else if(mTypDisp==1) sprintf(str,"h2disp=pts,%g",mFPoints);
+    else if(mTypDisp==2) sprintf(str,"h2disp=hbk");
+      else if(mTypDisp==3) sprintf(str,"h2disp=img");
+ opt.push_back(str);
+
+ if(mTypScal==0) sprintf(str,"h2scale=lin");
+   else if(mTypScal==1) sprintf(str,"h2disp=log,%g",mLogScale);
+ opt.push_back(str);
+
+ sprintf(str,"h2dyn=%g,%g",mHMin,mHMax);
+ opt.push_back(str);
+
+ sprintf(str,"h2frac=%g,%g",mFracMin,mFracMax);
+ opt.push_back(str);
+
+ if(mRevCmap) opt.push_back("revcmap");
+
+ return 1;
+}
+
+
 //++
 void PIHisto2D::GetOptionsHelpInfo(string& info)
Index: trunk/SophyaPI/PIext/pihisto2d.h
===================================================================
--- trunk/SophyaPI/PIext/pihisto2d.h	(revision 2522)
+++ trunk/SophyaPI/PIext/pihisto2d.h	(revision 2523)
@@ -52,4 +52,5 @@
   //   Methode de decodage des options
   virtual int  DecodeOptionString(vector<string> & opt, bool rmdecopt=true);
+  virtual int  OptionToString(vector<string> & opt) const;
   virtual void GetOptionsHelpInfo(string& info);
 