Index: trunk/SophyaPI/PIext/basexecut.cc
===================================================================
--- trunk/SophyaPI/PIext/basexecut.cc	(revision 2536)
+++ trunk/SophyaPI/PIext/basexecut.cc	(revision 2545)
@@ -17,4 +17,5 @@
 #include "piyfxdrw.h"
 #include "pibargraph.h"
+#include "pitxtdrw.h"
 
 #include "histos.h"
@@ -751,4 +752,16 @@
   string grname = "BarGraph";
   mImgApp->DispScDrawer(bgd, grname, tokens[0]); 
+}
+else if (kw == "textdrawer") {
+  if (tokens.size() < 2) { 
+    cout << "Usage: textdrawer gr_opt line1 [line2 ...]" << endl;
+    return(0); 
+  }
+  PITextDrawer* txd = new PITextDrawer;
+  for(int k=1; k<tokens.size(); k++)
+    txd->AddLine(tokens[k]);
+  string grname = "TextDrawer";
+  tokens[0] += " inset";
+  mImgApp->DispScDrawer(txd, grname, tokens[0]); 
 }
 
@@ -1617,7 +1630,12 @@
 mpiac->RegisterCommand(kw, usage, this, "Obj. Display");
 kw = "bargraph";
-usage = "Bar-Graph view of a sequence of values ";
+usage = "Bar-Graph view of a sequence of values (test)";
 usage += "\n Usage : bargraph graphic_attributes v1 [v2 v3 ...] ";
 usage += "\n  Related commands: disp nt2d vecplot";  
+mpiac->RegisterCommand(kw, usage, this, "Obj. Display");
+kw = "textdrawer";
+usage = "Multi line text darwer (test)";
+usage += "\n Usage : textdrawer graphic_attributes line1 [line2 line3 ...] ";
+usage += "\n  Related commands: disp ";  
 mpiac->RegisterCommand(kw, usage, this, "Obj. Display");
 
@@ -1907,4 +1925,5 @@
 usage += "o <Alt>O : Shows the PIImageTools (image display parameter controls) \n";
 usage += "o <Alt>G : Show the PIDrawerTools (Graphic attributes of overlayed graphics (Drawers)) \n";
+usage += "o <Alt>D : Shows the drawer manipulation pop-up menu \n";
 usage += "o <Alt>V : Copy/Paste / Text paste at the current cursor position \n";
 usage += "o <Alt>C : Copy/Paste / Copies the selected regions content as text in the copy/paste buffer \n";
@@ -1926,7 +1945,8 @@
 usage += "o <Alt>R : Refresh display \n";
 usage += "o <Alt>O : Displays a specific control window (default: PIDrawerTools) \n";
-usage += "           Specific controls for 2-D histograms \n";
+usage += "           (2-D histograms, contour plot ...) \n";
 usage += "o <Alt>G : Show the PIDrawerTools (Graphic attributes of displayed Drawers) \n";
 usage += "           Drawer 0 manages the axes, as well as the added text \n";
+usage += "o <Alt>D : Shows the drawer manipulation pop-up menu \n";
 usage += "o <Alt>V : Copy/Paste / Text paste at the current position \n";
 usage += "o <Alt>Z : Removes added graphic elements (handled by BaseDrawer - 0) \n";
@@ -1948,6 +1968,9 @@
 usage += ">>>> Keyboard controls : \n";
 usage += "o <Alt>R : Resets the 3-D view and refreshes the display \n";
+usage += "o <Alt>O : Displays a specific control window (default: PIDrawerTools) \n";
+usage += "           (2-D histograms, contour plot ...) \n";
 usage += "o <Alt>G : Show the PIDrawerTools (Graphic attributes of displayed Drawers) \n";
-usage += "o <Alt>O : = <Alt>G \n";
+usage += "           Drawer 0 manages the axes, as well as the added text \n";
+usage += "o <Alt>D : Shows the drawer manipulation pop-up menu \n";
 usage += "o <Alt>V : Copy/Paste / Text paste at the current position (Drawer 0)\n";
 usage += "o <Alt>Z : Removes added graphic elements (handled by BaseDrawer - 0) \n";
Index: trunk/SophyaPI/PIext/pintup3d.cc
===================================================================
--- trunk/SophyaPI/PIext/pintup3d.cc	(revision 2536)
+++ trunk/SophyaPI/PIext/pintup3d.cc	(revision 2545)
@@ -48,5 +48,5 @@
   mNT = nt;
   mAdDO = ad; 
-  mAutoScaleXY = mAutoScaleZ = true;
+  aScxy = aScz = true;
   UseSizeScale(true, 5);
   UseColorScale(true);
@@ -142,5 +142,5 @@
 
   ComputeScaleFactor(xmin, xmax, ymin, ymax, zmin, zmax, 
-		     mAutoScaleXY, mAutoScaleZ, mScy, mScz);
+		     aScxy, aScz, mScy, mScz);
   
   // cout << " DEBUG - NTup3D X:" << XMin3() << "-" << XMax3() " s=" << mScx
@@ -313,8 +313,8 @@
       UseSizeScale(true, nbn);
     }
-    else if (opts == "rescalexy") mAutoScaleXY = true;
-    else if (opts == "norescalexy") mAutoScaleXY = false;
-    else if (opts == "rescalez") mAutoScaleZ = true;
-    else if (opts == "norescalez") mAutoScaleZ = false;
+    else if (opts == "rescalexy") aScxy = true;
+    else if (opts == "norescalexy") aScxy = false;
+    else if (opts == "rescalez") aScz = true;
+    else if (opts == "norescalez") aScz = false;
     else {
       // Si option non decode
@@ -346,8 +346,8 @@
  } else opt.push_back("nosizescale");
 
- if(mAutoScaleXY) opt.push_back("rescalexy");
+ if(aScxy) opt.push_back("rescalexy");
    else opt.push_back("norescalexy");
 
- if(mAutoScaleZ) opt.push_back("rescalez");
+ if(aScz) opt.push_back("rescalez");
    else opt.push_back("norescalez");
 
Index: trunk/SophyaPI/PIext/pintup3d.h
===================================================================
--- trunk/SophyaPI/PIext/pintup3d.h	(revision 2536)
+++ trunk/SophyaPI/PIext/pintup3d.h	(revision 2545)
@@ -38,5 +38,4 @@
   NTupleInterface* mNT;
   bool mAdDO;
-  bool mAutoScaleXY, mAutoScaleZ;
   int xK, yK, zK;           // Index du nom de variable en X/Y/Z ds le ntuple
   int xebK, yebK, zebK;     // Index du nom de variable en ErrBarX/Y/Z ds le ntuple